<?php
/**
 * Controller to handling save coupon
 *
 * @package wp-checkout-maximizer
 * @author InstaProduct
 * @link http://insta-product.com/
 */

if ( ! class_exists( 'IPChm_Ajax_Coupon' ))
{
  class IPChm_Ajax_Coupon
  {
    /**
     * Execution save coupon
     *
     * @return void
     */
    public function exec()
    {
      $status = 0;
      $info   = array();

      if ( ! empty( $_POST['code'] ) && ! empty( $_POST['postId'] ))
      {
        $postId = absint( $_POST['postId'] );
        $post   = get_post( $postId );
        if ( $post )
        {
          $setting = new IPChm_Setting( $post->ID, '__ipchm-setting' );
          $code    = $setting->getSetting( 'coupon_codes' );
          $codes   = explode( "\n", $code );
          foreach( $codes as $k => $_c ) {
            $codes[$k] = trim( $_c );
          }
          if ( in_array( $_POST['code'], $codes ))
          {
            $price    = $setting->getSetting( 'coupon_discount' );
            $prefix   = get_option( '__ipchm_prefix', '$' );
            $decimals = get_option( '__ipchm_decimals', 2 );
            $point    = get_option( '__ipchm_decimal_point', '.' );
            $sep      = get_option( '__ipchm_thousands_separator', ',' );
            $priceText = $prefix . number_format( $price, $decimals, $point, $sep );

            $status = 1;
            $info   = array(
              'title'     => stripslashes( $setting->getSetting( 'coupon_order_label' )),
              'price'     => $price,
              'priceText' => $priceText
            );
          }
        }
      }

      echo json_encode( array(
          'status' => $status,
          'info'   => $info
      ) );
      die();
    }
  }
}
